<?php

namespace Teknisa\CRM\Controller;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Session;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Method;

class PerformanceEvaluation {

    protected $dataSourceName = 'performance_evaluation';
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function get($request, $response) {
        $session = new \Zeedhi\Framework\Session\Session();
        $operator = (int)$session->get('operator');
        $nrorg    = (int)$session->get('nrorg');

        // leonardocarvalho - 27/11/2014 - Adicionado parâmetro para NRORG
        $where = array(
            "P_OPERATOR" => $operator,
            "P_NRORG" => $nrorg
        );

       // leonardocarvalho - 27/11/2014 - Alterado para verificar nrorg
        $sql =
            "SELECT DISTINCT NMTIPOAVALIACAO,
              AVALIACAOGERAL.NMAVALIACAO,
              PARTICIPAVAL.idsituacaoaval SITUACAO,
              TO_CHAR(DTINIREALIZAVAL, 'DD/MM/YYYY') AS DTINIREALIZAVAL,
              TO_CHAR(DTFIMREALIZAVAL, 'DD/MM/YYYY') AS DTFIMREALIZAVAL,
              EXECAVALIACAO.NRPARCEXECAVAL AS NRPARCEXECAVAL,
              EXECAVALIACAO.NRPARCAVALIADO AS NRPARCAVALIADO,
              EXECAVALIACAO.NRAVALIACAO,
              TO_CHAR(EXECAVALIACAO.DTEXECUCAOAVAL, 'DD/MM/YYYY') AS DTEXECUCAOAVAL,
              EXECAVALIACAO.NRCOMBQUESTAVAL,
              TIPORELACIONA.NMTIPORELACIONA,
              EXEC.NRPARCNEGOCIO NRAVALIADOR,
              EXEC.NMPRINCIPALPARC AVALIADOR,
              APLIC.NRPARCNEGOCIO NRAVALIADO,
              'ATENDENTE: '||APLIC.NMPRINCIPALPARC AVALIADO
            FROM EXECAVALIACAO,
              AVALIACAOGERAL,
              TIPOAVALIACAO,
              TIPORELACIONA,
              PARTICIPAVAL,
              PARCNEGOCIO EXEC,
              PARCNEGOCIO APLIC,
              OPERADOR
            WHERE AVALIACAOGERAL.NRTIPOAVALIACAO = TIPOAVALIACAO.NRTIPOAVALIACAO
            AND PARTICIPAVAL.NRTIPORELACIONA     = TIPORELACIONA.NRTIPORELACIONA
            AND PARTICIPAVAL.nrparcavaliado      = EXECAVALIACAO.nrparcavaliado
            AND PARTICIPAVAL.nrparcexecaval      = EXECAVALIACAO.nrparcexecaval
            AND PARTICIPAVAL.nravaliacao         = EXECAVALIACAO.nravaliacao
            AND EXEC.NRPARCNEGOCIO               = EXECAVALIACAO.NRPARCEXECAVAL
            AND APLIC.NRPARCNEGOCIO              = EXECAVALIACAO.NRPARCAVALIADO
            AND EXECAVALIACAO.NRORG              = AVALIACAOGERAL.NRORG
            AND EXECAVALIACAO.NRAVALIACAO        = AVALIACAOGERAL.NRAVALIACAO
            AND OPERADOR.NRPARCNEGOCIO           = EXEC.NRPARCNEGOCIO
            AND OPERADOR.NRORG                   = EXEC.NRORG
            AND OPERADOR.NRORG
                      = APLIC.NRORG
            AND OPERADOR.NRORG                   = PARTICIPAVAL.NRORG
            AND OPERADOR.NRORG                   = EXECAVALIACAO.NRORG
            AND (OPERADOR.CDOPERADOR             = LPAD(:P_OPERATOR, 12, 0) OR OPERADOR.CDOPERADOR = :P_OPERATOR)
            AND OPERADOR.NRORG                   = :P_NRORG
            AND SYSDATE BETWEEN (DTINIREALIZAVAL) AND TRUNC(DTFIMREALIZAVAL) +1
            AND PARTICIPAVAL.IDSITUACAOAVAL NOT LIKE '%CONCLUIDA%'
            ORDER BY DECODE(PARTICIPAVAL.idsituacaoaval, 'PENDENTE', 1, 'ANDAMENTO', 2, 3), TIPORELACIONA.NMTIPORELACIONA";
            //AND PARTICIPAVAL.nrcombquestaval     = EXECAVALIACAO.nrcombquestaval

        $data = $this->entityManager->getConnection()->fetchAll($sql,$where);

        //$response->addMethod(new Method('setLocalVar', array('NRORG', $nrorg)));
        //$response->addMethod(new Method('setLocalVar', array('CDOPERADOR', $operator)));
        $response->addDataset(new DataSet('performance_evaluation', $data));

    }
}