<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\Model\Util\NovoCodigo;

class crm00002007InterlocutorController extends TeknisaCrud {
    
    protected $dataSourceName = 'crm_interlocutor';
    protected $parameterBagColumns = array('NRORG', 'P_NRORGPADRAO');
    
    public function findInterlocParc(Request $request, Response $response) {
        $this->dataSourceName = 'crm_interlocutor_parcnegocio';
        parent::find($request, $response);
    }
    
    public function save(Request $request, Response $response) {
        try {
            $row = $request->getRow();
        if (array_key_exists('NRSEQINTERLOCUTOR', $row)) {
            if ($row['__is_new']) {
                $row['NRSEQINTERLOCUTOR'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_INTERLOCUTOR", 1, 10, false, true);
            }
        }else{
             $row['NRSEQINTERLOCUTOR'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_INTERLOCUTOR", 1, 10, false, true);
        }
        parent::save($request, $response);
    } catch(\Exception $e) {
        $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
    }
  }
}

