<?php

require __DIR__."/../../../../vendor/autoload.php";
require __DIR__."/../../../../vendor/zeedhi/framework/bootstrap.php";
require __DIR__."/../../../../vendor/teknisa/libraries/scripts/bootstrap.php";
require __DIR__."/../../../../vendor/teknisa/zeedhiApiKeys/bootstrap.php";
require __DIR__."/../../../../src/PHPExcel/PHPExcel.php";
require __DIR__."/../../../../src/PHPImap/__autoload.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$instanceManager->loadFromFile(__DIR__."/../../../../config/db.xml");
$instanceManager->loadFromFile(__DIR__."/../../../../config/base.xml");
$instanceManager->loadFromFile(__DIR__."/../../../../config/parameters.xml");
$instanceManager->loadFromFile(__DIR__."/../../../../config/general.xml");
$instanceManager->loadFromFile(__DIR__."/../../../../config/report.xml");
$instanceManager->loadFromFile(__DIR__."/environmentJob.xml");
$instanceManager->loadFromFile(__DIR__."/../../../../vendor/teknisa/libraries/services.xml");

$routes = array();

/*==============================================================================*/

$container = $instanceManager->getContainer();

if ($container->hasParameter('use_zhu_acl') && $container->getParameter('use_zhu_acl') == 'true'){
    $acl = __DIR__ . '/../../../../../modules/acl/backend/config/acl.xml';

    if(realpath($acl)){
        $instanceManager->loadFromFile($acl);
    }
    require __DIR__ . "/../../../../vendor/zeedhi/zhuaclbackend/service/bootstrap.php";
    $routes[] = __DIR__ . "/../../../../vendor/zeedhi/zhuaclbackend/config/routes.json";
}

if ($container->hasParameter('use_zhu_update') && $container->getParameter('use_zhu_update') == 'true'){
    $zhu = __DIR__ . '/../../../../../modules/acl/backend/config/zhuUpdate.xml';

    if(realpath($zhu)){
        $instanceManager->loadFromFile($zhu);
    }
}

if ($container->hasParameter('use_zhu_log') && $container->getParameter('use_zhu_log') == 'true') {
    $zhuDateFormat = $container->getParameter('zhuLogDateFormat');
    $ignoredRoutes = $container->hasParameter('logIgnoredRoutes') ? $container->getParameter('logIgnoredRoutes') : [];

    require __DIR__ . "/../../../../vendor/zeedhi/zhulog/config/bootstrap.php";
    $routes[] = __DIR__ . "/../../../../vendor/zeedhi/zhulog/config/routes.json";

    $log = __DIR__.'/../../../../../modules/acl/backend/config/log.xml';
    if(realpath($log)){
        $instanceManager->loadFromFile($log);
    }

    $libLog = __DIR__.'/../../../../vendor/teknisa/libraries/zhuLog.xml';
    if(realpath($libLog)){
        $instanceManager->loadFromFile($libLog);
    }

    $container->setParameter('logIgnoredRoutes', $ignoredRoutes);
    $container->setParameter('zhuLogDateFormat', $zhuDateFormat);
}

/*==============================================================================*/

$productMapping = file_get_contents(__DIR__.'/../../../../config/servicesMapping.json');
$productMapping = json_decode($productMapping, true);

foreach ($productMapping as $path) {
    $ext = substr(strrchr($path, '.'),1);
    if ($ext === 'xml') {
        $instanceManager->loadFromFile(__DIR__.'/../../../../'.$path);
    } elseif ($ext === 'json') {
        $routes[] = __DIR__.$path;
    }
}

/*==============================================================================*/

$routes[] = __DIR__ . "/../../../../vendor/teknisa/libraries/libRoutes.json";

/*==============================================================================*/
$instanceManager->loadFromFile(__DIR__."/../../../../config/fileServer.xml");
$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();

use Doctrine\DBAL\Types\Type;
Type::overrideType(Type::DATE, 'Setforms2\Shared\ORM\DateType');
Type::overrideType(Type::DATETIME, 'Setforms2\Shared\ORM\DateTimeType');

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());