function IndicadorLeadController(templateManager, ScreenService, Utilities, restEngine, General, metaDataFactory, CRM_Utilities, ZHPromise, Dashboard_Controller, ZhReports, ZhFilterPreferences){
    
    this.cascadeReload = function(widget){
        widget.widgets.forEach(function(childWid){
            childWid.dataSource.data = widget.dataSource.data;
            if(childWid.template.indexOf('chart') !== -1 && widget.currentWidget.name === childWid.name){
                childWid.updateChart();
            }
            if(childWid.name === 'WDGT_GRID_LEADS'){
                this.afterLoadDataSourceReport(childWid, false);
            }
        }.bind(this));
    };
    
    this.filterAfterApplyReport = function(args){
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        
        var stripeLabel;
        
        if(filterRow.INTERVALO) {
            var start = filterRow.INTERVALO.start;
            var end = filterRow.INTERVALO.end;
            
            stripeLabel = start ? start + ' a ' + end : "";
        } else {
            stripeLabel = "";
        }
        
        stripe.getField('SELECTEDMONTH').label = stripeLabel;
        widget.activate();
    };
    
    this.onEnterOnceReport = function(widget){
        this.openFilter(widget);
        
        widget.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;
        var filteredMonth = templateManager.container.getWidget("WDGT_TAB_INDICADORLEAD").currentRow.ORDEM.slice(0,2);
        var filteredYear  = templateManager.container.getWidget("WDGT_TAB_INDICADORLEAD").currentRow.ORDEM.slice(3,5);
        
        var start = '01/'+filteredMonth+'/20'+filteredYear;
        var lastday = new Date(2000+parseInt(filteredYear), parseInt(filteredMonth), 0).getDate();
        var end = lastday+'/'+filteredMonth+'/20'+filteredYear;
        widget.currentRow.INTERVALO = {
            start:start,
            end:end
        };
    };
    
    this.openFilter = function(widget) {
        var fieldsToApply = [];
        
        CRM_Utilities.openFilterOnEnter(widget, widget.currentRow, fieldsToApply);
    };
    
    this.afterLoadDataSourceReport = function(widget, cascadeReload){
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        var chart = templateManager.container.getWidget('WDGT_INDICADOR_LEADS');
        
        widget.dataSource.data.forEach(function(row){
            row.MES =  stripe.getField('SELECTEDMONTH').label;
            row.INTERVALO =  stripe.getField('SELECTEDMONTH').label;
        });  
        
        if(cascadeReload){
            chart.dataSource.data = widget.dataSource.data;
        }
        
        widget.redraw();
    };
    
    this.generateReport = function(widget, option){
        var widgetToReport = templateManager.container.getWidget('WDGT_TO_REPORT');
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        widget = widget || templateManager.container.getWidget('WDGT_GRID_LEADS');
        
        //Numbers to String
        widget.dataSource.data.forEach(function(row){
        	Object.keys(row).forEach(function(key){
            	if(typeof row[key] === "number")
        			row[key] = row[key].toString();
        	});
        });
        
        widgetToReport.dataSource.data = widget.dataSource.data;
        widgetToReport.fields = widget.fields;
        var label = widgetToReport.getField('MES').label;
        label = label.indexOf('De') ? stripe.fields[1].label : 'De '+stripe.fields[1].label;  
        
        if(option === 'XLS'){
            widgetToReport.getField('MES').label = 'Período';
            widgetToReport.getField('MES').isVisibleOnReport = true;
            widgetToReport.getField('MES').isVisible = true;
        }else{
            widgetToReport.getField('MES').label = label;
            widgetToReport.getField('MES').isVisibleOnReport = false;
            widgetToReport.getField('MES').isVisible = false;
        }
        ZhReports.openReport(widget.dataSource.data, widgetToReport, null, null, option);
        widgetToReport.getField('MES').label = 'Período';
    };
	
	this.setDefaultParameters = function(widget, mes) {
	    if(!widget.currentRow.ORDEM) {
	        widget.currentRow.ORDEM = moment().subtract(1, 'M').format('MM/YY');
	    }
	    
	    var mes = widget.currentRow.ORDEM;
        var ano = mes.slice(3,5);
        
        var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;
	    
	    var widgetChart = templateManager.container.getWidget('WDGT_TAB_INDICADORLEAD');
        var lastday = new Date(2000+ano, parseInt(mes.slice(0,2)), 0).getDate();
        widgetChart.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                static: true,
                value: templateManager.LOGGEDOPERATOR.NRORG
            },
            {
                name: "P_CRM_NRORGTRAB",
                operator: "=",
                static: true,
                value: getLocalVar('CRM_NRORGTRABALHO')
            },
            {
                name: "P_CDOPERADORES",
                operator: "IN",
                static: true,
                value: operadores
            },
            {
                name: "DATAINICIAL",
                operator: "=",
                static: true,
                value: "01/"+mes+" 00:00"
            },
            {
                name: "DATAFINAL",
                operator: "=",
                static: true,
                value:lastday+'/'+mes+" 23:59"
            }
        ];
        widgetChart.currentRow['MES'] = mes;
        widgetChart.currentRow['ORDEM'] = widget.currentRow.ORDEM;
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        stripe.fields[0].label = 'Leads Cadastrados x Convertidos';
        //Replace pra pegar o ano no LocaleString
        stripe.fields[1].label = new Date(mes.replace('/', '/01/')).toLocaleString('pt-BR', {month:'long', year:'numeric'});
        stripe.fields[1].label = CRM_Utilities.capitalizeFirstLetter(stripe.fields[1].label);
        stripe.chart = 'leads_cadastrados_convertidos';
        widget.activate();
        widgetChart.reload();
	}
}
Configuration(function(ContextRegister){
    ContextRegister.register('IndicadorLeadController', IndicadorLeadController);
});