var CRM_ParceiroNegocio_Service = function (CRM_ParceiroNegocio_Repository) {

    var defaultTiposParceiro = [
        "CLIENTE",
        "PROSPECT",
        "CANDIDATO",
        "PESSOA",
        "OPERADOR",
        "FUNCIONARIO",
        "FORNECEDOR",
        "TRANSPORTADORA",
        "VENDEDOR",
        "INTERLOCUTOR",
        "REVENDA"
    ];

    var tipoInscricao = {
        "F": "CPF",
        "I": "LIVRE",
        "J": "CNPJ",
        "O": "CODIGO"
    };

    this.getTipoInscricao = function(tipoDefault) {
        return tipoInscricao[tipoDefault];
    };

    this.salvarComunicacao = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarComunicacao(row);
    };
    
    this.salvarContato = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarContato(row);
    };

    this.salvarEndereco = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarEndereco(row);
    };

    this.salvarParceiro = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarParceiro(row);
    };

    this.setTipoPrincipal = function(row) {
        var tipos = row.TIPODEPARCEIRO;
        
        if (Array.isArray(tipos) && tipos.length > 0) {
            var i = 0;
            var tipoPrincipal = null;
            while (tipoPrincipal === null && i < defaultTiposParceiro.length) {
                if (tipos.indexOf(defaultTiposParceiro[i]) !== -1) {
                    tipoPrincipal = defaultTiposParceiro[i];
                }
                i++;
            }
            row.CDTIPOPARCPRINCIPAL = tipoPrincipal;
        }
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('CRM_ParceiroNegocio_Service', CRM_ParceiroNegocio_Service);
});